<?php

namespace Pixelboxx;

/**
 * Class which returns the class map definition
 * @package
 */
class ClassMap
{
    /**
     * Returns the mapping between the WSDL Structs and generated Structs' classes
     * This array is sent to the \SoapClient when calling the WS
     * @return string[]
     */
    final public static function get()
    {
        return array(
            'ValueType' => '\\Pixelboxx\\StructType\\ValueType',
            'MLAttributeType' => '\\Pixelboxx\\StructType\\MLAttributeType',
            'DisplayNameType' => '\\Pixelboxx\\StructType\\DisplayNameType',
            'DisplayableAttributeType' => '\\Pixelboxx\\StructType\\DisplayableAttributeType',
            'AttributeType' => '\\Pixelboxx\\StructType\\AttributeType',
            'AttributeListType' => '\\Pixelboxx\\StructType\\AttributeListType',
            'AttributeReqType' => '\\Pixelboxx\\StructType\\AttributeReqType',
            'ACAttributeListType' => '\\Pixelboxx\\StructType\\ACAttributeListType',
            'AttributeUsageType' => '\\Pixelboxx\\StructType\\AttributeUsageType',
            'TypeInfoType' => '\\Pixelboxx\\StructType\\TypeInfoType',
            'LanguageRequestType' => '\\Pixelboxx\\StructType\\LanguageRequestType',
            'RawDataLocationType' => '\\Pixelboxx\\StructType\\RawDataLocationType',
            'ImageAttributesType' => '\\Pixelboxx\\StructType\\ImageAttributesType',
            'RawDataType' => '\\Pixelboxx\\StructType\\RawDataType',
            'RawDataListType' => '\\Pixelboxx\\StructType\\RawDataListType',
            'AbstractObjectType' => '\\Pixelboxx\\StructType\\AbstractObjectType',
            'ObjectType' => '\\Pixelboxx\\StructType\\ObjectType',
            'ItemType' => '\\Pixelboxx\\StructType\\ItemType',
            'FolderType' => '\\Pixelboxx\\StructType\\FolderType',
            'Content' => '\\Pixelboxx\\StructType\\Content',
            'FolderStructureType' => '\\Pixelboxx\\StructType\\FolderStructureType',
            'CommonRequestParamType' => '\\Pixelboxx\\StructType\\CommonRequestParamType',
            'DataSpecificationType' => '\\Pixelboxx\\StructType\\DataSpecificationType',
            'MetadataRequestType' => '\\Pixelboxx\\StructType\\MetadataRequestType',
            'ConversionType' => '\\Pixelboxx\\StructType\\ConversionType',
            'ScalingType' => '\\Pixelboxx\\StructType\\ScalingType',
            'ImageOpParamType' => '\\Pixelboxx\\StructType\\ImageOpParamType',
            'ImageOpType' => '\\Pixelboxx\\StructType\\ImageOpType',
            'ImageProcessorParamsType' => '\\Pixelboxx\\StructType\\ImageProcessorParamsType',
            'RawDataRequestType' => '\\Pixelboxx\\StructType\\RawDataRequestType',
            'RawDataListRequestType' => '\\Pixelboxx\\StructType\\RawDataListRequestType',
            'XLinkObjectsRequestType' => '\\Pixelboxx\\StructType\\XLinkObjectsRequestType',
            'XLinkListObjectsRequestType' => '\\Pixelboxx\\StructType\\XLinkListObjectsRequestType',
            'XLinkObjectsType' => '\\Pixelboxx\\StructType\\XLinkObjectsType',
            'XLinkListObjectsType' => '\\Pixelboxx\\StructType\\XLinkListObjectsType',
            'OrderAttributeType' => '\\Pixelboxx\\StructType\\OrderAttributeType',
            'OrderAttributesType' => '\\Pixelboxx\\StructType\\OrderAttributesType',
            'RangeType' => '\\Pixelboxx\\StructType\\RangeType',
            'CommonSearchParamType' => '\\Pixelboxx\\StructType\\CommonSearchParamType',
            'SimpleSearchParamType' => '\\Pixelboxx\\StructType\\SimpleSearchParamType',
            'SearchInFolderType' => '\\Pixelboxx\\StructType\\SearchInFolderType',
            'SearchXLinkType' => '\\Pixelboxx\\StructType\\SearchXLinkType',
            'SearchAttributeType' => '\\Pixelboxx\\StructType\\SearchAttributeType',
            'SearchStringType' => '\\Pixelboxx\\StructType\\SearchStringType',
            'AndTerm' => '\\Pixelboxx\\StructType\\AndTerm',
            'OrTerm' => '\\Pixelboxx\\StructType\\OrTerm',
            'NotTerm' => '\\Pixelboxx\\StructType\\NotTerm',
            'SolrQueryTermType' => '\\Pixelboxx\\StructType\\SolrQueryTermType',
            'SearchTerm' => '\\Pixelboxx\\StructType\\SearchTerm',
            'ExtendedSearchParamType' => '\\Pixelboxx\\StructType\\ExtendedSearchParamType',
            'MessageType' => '\\Pixelboxx\\StructType\\MessageType',
            'IDListType' => '\\Pixelboxx\\StructType\\IDListType',
            'UpdateXLinkType' => '\\Pixelboxx\\StructType\\UpdateXLinkType',
            'UpdateXLinkListType' => '\\Pixelboxx\\StructType\\UpdateXLinkListType',
            'UpdateXLink' => '\\Pixelboxx\\StructType\\UpdateXLink',
            'GetFolderStructureRequest' => '\\Pixelboxx\\StructType\\GetFolderStructureRequest',
            'CreateFolderRequest' => '\\Pixelboxx\\StructType\\CreateFolderRequest',
            'DeleteFolderRequest' => '\\Pixelboxx\\StructType\\DeleteFolderRequest',
            'GetFolderRequest' => '\\Pixelboxx\\StructType\\GetFolderRequest',
            'AddObjectToFolderRequestType' => '\\Pixelboxx\\StructType\\AddObjectToFolderRequestType',
            'MoveObjectRequestType' => '\\Pixelboxx\\StructType\\MoveObjectRequestType',
            'ImportFileRequest' => '\\Pixelboxx\\StructType\\ImportFileRequest',
            'DeleteObjectRequest' => '\\Pixelboxx\\StructType\\DeleteObjectRequest',
            'RemoveObjectFromFolderRequest' => '\\Pixelboxx\\StructType\\RemoveObjectFromFolderRequest',
            'GetObjectRequest' => '\\Pixelboxx\\StructType\\GetObjectRequest',
            'UpdateObjectRequest' => '\\Pixelboxx\\StructType\\UpdateObjectRequest',
            'ImportFileNewVersionRequest' => '\\Pixelboxx\\StructType\\ImportFileNewVersionRequest',
            'GetTypeInfoRequest' => '\\Pixelboxx\\StructType\\GetTypeInfoRequest',
            'CreateObjectRequest' => '\\Pixelboxx\\StructType\\CreateObjectRequest',
            'XLinkListRefsType' => '\\Pixelboxx\\StructType\\XLinkListRefsType',
            'XLinkRefsType' => '\\Pixelboxx\\StructType\\XLinkRefsType',
            'SuccessMessageResponse' => '\\Pixelboxx\\StructType\\SuccessMessageResponse',
            'FolderStructureResponse' => '\\Pixelboxx\\StructType\\FolderStructureResponse',
            'FolderResponse' => '\\Pixelboxx\\StructType\\FolderResponse',
            'ObjectResponse' => '\\Pixelboxx\\StructType\\ObjectResponse',
            'GetTypeInfoResponse' => '\\Pixelboxx\\StructType\\GetTypeInfoResponse',
            'RenameFolderRequest' => '\\Pixelboxx\\StructType\\RenameFolderRequest',
            'MultiValueFacetSpecType' => '\\Pixelboxx\\StructType\\MultiValueFacetSpecType',
            'RangeFacetSpecType' => '\\Pixelboxx\\StructType\\RangeFacetSpecType',
            'FacetSpecType' => '\\Pixelboxx\\StructType\\FacetSpecType',
            'AbstractFacetType' => '\\Pixelboxx\\StructType\\AbstractFacetType',
            'ValueFacetType' => '\\Pixelboxx\\StructType\\ValueFacetType',
            'RangeFacetType' => '\\Pixelboxx\\StructType\\RangeFacetType',
            'FacetType' => '\\Pixelboxx\\StructType\\FacetType',
            'FacetGroupType' => '\\Pixelboxx\\StructType\\FacetGroupType',
            'SearchRequest' => '\\Pixelboxx\\StructType\\SearchRequest',
            'SearchResultContentType' => '\\Pixelboxx\\StructType\\SearchResultContentType',
            'SearchResponse' => '\\Pixelboxx\\StructType\\SearchResponse',
            'GetUsageListRequest' => '\\Pixelboxx\\StructType\\GetUsageListRequest',
            'UsageInfoResultType' => '\\Pixelboxx\\StructType\\UsageInfoResultType',
            'UsageListResultType' => '\\Pixelboxx\\StructType\\UsageListResultType',
            'GetUsageListResponse' => '\\Pixelboxx\\StructType\\GetUsageListResponse',
            'UsageListEntryType' => '\\Pixelboxx\\StructType\\UsageListEntryType',
            'UpdateUsageListRequest' => '\\Pixelboxx\\StructType\\UpdateUsageListRequest',
            'WSAuthorizationFault' => '\\Pixelboxx\\StructType\\WSAuthorizationFault',
            'WSObjectNotFoundFault' => '\\Pixelboxx\\StructType\\WSObjectNotFoundFault',
        );
    }
}
