<?php

namespace Pixelboxx\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for AndTerm StructType
 * @subpackage Structs
 */
class AndTerm extends AbstractStructBase
{
    /**
     * The SearchTerm
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 2
     * - ref: pb:SearchTerm
     * @var \Pixelboxx\StructType\SearchTerm[]
     */
    public $SearchTerm;
    /**
     * Constructor method for AndTerm
     * @uses AndTerm::setSearchTerm()
     * @param \Pixelboxx\StructType\SearchTerm[] $searchTerm
     */
    public function __construct(array $searchTerm = array())
    {
        $this
            ->setSearchTerm($searchTerm);
    }
    /**
     * Get SearchTerm value
     * @return \Pixelboxx\StructType\SearchTerm[]
     */
    public function getSearchTerm()
    {
        return $this->SearchTerm;
    }
    /**
     * This method is responsible for validating the values passed to the setSearchTerm method
     * This method is willingly generated in order to preserve the one-line inline validation within the setSearchTerm method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateSearchTermForArrayConstraintsFromSetSearchTerm(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $andTermSearchTermItem) {
            // validation for constraint: itemType
            if (!$andTermSearchTermItem instanceof \Pixelboxx\StructType\SearchTerm) {
                $invalidValues[] = is_object($andTermSearchTermItem) ? get_class($andTermSearchTermItem) : sprintf('%s(%s)', gettype($andTermSearchTermItem), var_export($andTermSearchTermItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The SearchTerm property can only contain items of type \Pixelboxx\StructType\SearchTerm, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set SearchTerm value
     * @throws \InvalidArgumentException
     * @param \Pixelboxx\StructType\SearchTerm[] $searchTerm
     * @return \Pixelboxx\StructType\AndTerm
     */
    public function setSearchTerm(array $searchTerm = array())
    {
        // validation for constraint: array
        if ('' !== ($searchTermArrayErrorMessage = self::validateSearchTermForArrayConstraintsFromSetSearchTerm($searchTerm))) {
            throw new \InvalidArgumentException($searchTermArrayErrorMessage, __LINE__);
        }
        $this->SearchTerm = $searchTerm;
        return $this;
    }
    /**
     * Add item to SearchTerm value
     * @throws \InvalidArgumentException
     * @param \Pixelboxx\StructType\SearchTerm $item
     * @return \Pixelboxx\StructType\AndTerm
     */
    public function addToSearchTerm(\Pixelboxx\StructType\SearchTerm $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \Pixelboxx\StructType\SearchTerm) {
            throw new \InvalidArgumentException(sprintf('The SearchTerm property can only contain items of type \Pixelboxx\StructType\SearchTerm, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->SearchTerm[] = $item;
        return $this;
    }
}
