<?php

namespace Pixelboxx\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for AttributeUsageType StructType
 * Meta information extracted from the WSDL
 * - documentation: Informationen zu Verwendung eines Attributs (lesbar/schreibbar). Auf Wunsch erfolgt die Angabe des Attribut-Typs (wie in cmis:enumPropertyType) und ggf. die Attribut-Typ-ID (Zur Abfrage der zulässigen Werte mit dem entsprechenden
 * anderen Webservice über GetPropertyTypeDefinition)
 * @subpackage Structs
 */
class AttributeUsageType extends AbstractStructBase
{
    /**
     * The name
     * Meta information extracted from the WSDL
     * - use: required
     * @var string
     */
    public $name;
    /**
     * The read
     * Meta information extracted from the WSDL
     * - default: true
     * - use: optional
     * @var bool
     */
    public $read;
    /**
     * The write
     * Meta information extracted from the WSDL
     * - default: true
     * - use: optional
     * @var bool
     */
    public $write;
    /**
     * The typeid
     * Meta information extracted from the WSDL
     * - use: optional
     * @var string
     */
    public $typeid;
    /**
     * The type
     * Meta information extracted from the WSDL
     * - use: optional
     * @var string
     */
    public $type;
    /**
     * Constructor method for AttributeUsageType
     * @uses AttributeUsageType::setName()
     * @uses AttributeUsageType::setRead()
     * @uses AttributeUsageType::setWrite()
     * @uses AttributeUsageType::setTypeid()
     * @uses AttributeUsageType::setType()
     * @param string $name
     * @param bool $read
     * @param bool $write
     * @param string $typeid
     * @param string $type
     */
    public function __construct($name = null, $read = true, $write = true, $typeid = null, $type = null)
    {
        $this
            ->setName($name)
            ->setRead($read)
            ->setWrite($write)
            ->setTypeid($typeid)
            ->setType($type);
    }
    /**
     * Get name value
     * @return string
     */
    public function getName()
    {
        return $this->name;
    }
    /**
     * Set name value
     * @param string $name
     * @return \Pixelboxx\StructType\AttributeUsageType
     */
    public function setName($name = null)
    {
        // validation for constraint: string
        if (!is_null($name) && !is_string($name)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($name, true), gettype($name)), __LINE__);
        }
        $this->name = $name;
        return $this;
    }
    /**
     * Get read value
     * @return bool|null
     */
    public function getRead()
    {
        return $this->read;
    }
    /**
     * Set read value
     * @param bool $read
     * @return \Pixelboxx\StructType\AttributeUsageType
     */
    public function setRead($read = true)
    {
        // validation for constraint: boolean
        if (!is_null($read) && !is_bool($read)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($read, true), gettype($read)), __LINE__);
        }
        $this->read = $read;
        return $this;
    }
    /**
     * Get write value
     * @return bool|null
     */
    public function getWrite()
    {
        return $this->write;
    }
    /**
     * Set write value
     * @param bool $write
     * @return \Pixelboxx\StructType\AttributeUsageType
     */
    public function setWrite($write = true)
    {
        // validation for constraint: boolean
        if (!is_null($write) && !is_bool($write)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($write, true), gettype($write)), __LINE__);
        }
        $this->write = $write;
        return $this;
    }
    /**
     * Get typeid value
     * @return string|null
     */
    public function getTypeid()
    {
        return $this->typeid;
    }
    /**
     * Set typeid value
     * @param string $typeid
     * @return \Pixelboxx\StructType\AttributeUsageType
     */
    public function setTypeid($typeid = null)
    {
        // validation for constraint: string
        if (!is_null($typeid) && !is_string($typeid)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($typeid, true), gettype($typeid)), __LINE__);
        }
        $this->typeid = $typeid;
        return $this;
    }
    /**
     * Get type value
     * @return string|null
     */
    public function getType()
    {
        return $this->type;
    }
    /**
     * Set type value
     * @param string $type
     * @return \Pixelboxx\StructType\AttributeUsageType
     */
    public function setType($type = null)
    {
        // validation for constraint: string
        if (!is_null($type) && !is_string($type)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($type, true), gettype($type)), __LINE__);
        }
        $this->type = $type;
        return $this;
    }
}
