<?php

namespace Pixelboxx\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ConversionType StructType
 * Meta information extracted from the WSDL
 * - documentation: Angaben zur Konvertierung, z.Zt. nur das gewünschte Zielformat.
 * @subpackage Structs
 */
class ConversionType extends AbstractStructBase
{
    /**
     * The ContentType
     * Meta information extracted from the WSDL
     * - base: xs:token
     * @var string
     */
    public $ContentType;
    /**
     * Constructor method for ConversionType
     * @uses ConversionType::setContentType()
     * @param string $contentType
     */
    public function __construct($contentType = null)
    {
        $this
            ->setContentType($contentType);
    }
    /**
     * Get ContentType value
     * @return string|null
     */
    public function getContentType()
    {
        return $this->ContentType;
    }
    /**
     * Set ContentType value
     * @param string $contentType
     * @return \Pixelboxx\StructType\ConversionType
     */
    public function setContentType($contentType = null)
    {
        // validation for constraint: string
        if (!is_null($contentType) && !is_string($contentType)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($contentType, true), gettype($contentType)), __LINE__);
        }
        $this->ContentType = $contentType;
        return $this;
    }
}
