<?php

namespace Pixelboxx\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for FacetType StructType
 * Meta information extracted from the WSDL
 * - documentation: Facet - a specific value or range of values (for the FacetGroup's property) + the number of matches.
 * @subpackage Structs
 */
class FacetType extends AbstractStructBase
{
    /**
     * The ValueFacet
     * Meta information extracted from the WSDL
     * - choice: ValueFacet | RangeFacet
     * - choiceMaxOccurs: 1
     * - choiceMinOccurs: 1
     * @var \Pixelboxx\StructType\ValueFacetType
     */
    public $ValueFacet;
    /**
     * The RangeFacet
     * Meta information extracted from the WSDL
     * - choice: ValueFacet | RangeFacet
     * - choiceMaxOccurs: 1
     * - choiceMinOccurs: 1
     * @var \Pixelboxx\StructType\RangeFacetType
     */
    public $RangeFacet;
    /**
     * Constructor method for FacetType
     * @uses FacetType::setValueFacet()
     * @uses FacetType::setRangeFacet()
     * @param \Pixelboxx\StructType\ValueFacetType $valueFacet
     * @param \Pixelboxx\StructType\RangeFacetType $rangeFacet
     */
    public function __construct(\Pixelboxx\StructType\ValueFacetType $valueFacet = null, \Pixelboxx\StructType\RangeFacetType $rangeFacet = null)
    {
        $this
            ->setValueFacet($valueFacet)
            ->setRangeFacet($rangeFacet);
    }
    /**
     * Get ValueFacet value
     * @return \Pixelboxx\StructType\ValueFacetType|null
     */
    public function getValueFacet()
    {
        return isset($this->ValueFacet) ? $this->ValueFacet : null;
    }
    /**
     * This method is responsible for validating the value passed to the setValueFacet method
     * This method is willingly generated in order to preserve the one-line inline validation within the setValueFacet method
     * This has to validate that the property which is being set is the only one among the given choices
     * @param mixed $value
     * @return string A non-empty message if the values does not match the validation rules
     */
    public function validateValueFacetForChoiceConstraintsFromSetValueFacet($value)
    {
        $message = '';
        if (is_null($value)) {
            return $message;
        }
        $properties = [
            'RangeFacet',
        ];
        try {
            foreach ($properties as $property) {
                if (isset($this->{$property})) {
                    throw new \InvalidArgumentException(sprintf('The property ValueFacet can\'t be set as the property %s is already set. Only one property must be set among these properties: ValueFacet, %s.', $property, implode(', ', $properties)), __LINE__);
                }
            }
        } catch (\InvalidArgumentException $e) {
            $message = $e->getMessage();
        }
        return $message;
    }
    /**
     * Set ValueFacet value
     * This property belongs to a choice that allows only one property to exist. It is
     * therefore removable from the request, consequently if the value assigned to this
     * property is null, the property is removed from this object
     * @throws \InvalidArgumentException
     * @param \Pixelboxx\StructType\ValueFacetType $valueFacet
     * @return \Pixelboxx\StructType\FacetType
     */
    public function setValueFacet(\Pixelboxx\StructType\ValueFacetType $valueFacet = null)
    {
        // validation for constraint: choice(ValueFacet, RangeFacet)
        if ('' !== ($valueFacetChoiceErrorMessage = self::validateValueFacetForChoiceConstraintsFromSetValueFacet($valueFacet))) {
            throw new \InvalidArgumentException($valueFacetChoiceErrorMessage, __LINE__);
        }
        if (is_null($valueFacet) || (is_array($valueFacet) && empty($valueFacet))) {
            unset($this->ValueFacet);
        } else {
            $this->ValueFacet = $valueFacet;
        }
        return $this;
    }
    /**
     * Get RangeFacet value
     * @return \Pixelboxx\StructType\RangeFacetType|null
     */
    public function getRangeFacet()
    {
        return isset($this->RangeFacet) ? $this->RangeFacet : null;
    }
    /**
     * This method is responsible for validating the value passed to the setRangeFacet method
     * This method is willingly generated in order to preserve the one-line inline validation within the setRangeFacet method
     * This has to validate that the property which is being set is the only one among the given choices
     * @param mixed $value
     * @return string A non-empty message if the values does not match the validation rules
     */
    public function validateRangeFacetForChoiceConstraintsFromSetRangeFacet($value)
    {
        $message = '';
        if (is_null($value)) {
            return $message;
        }
        $properties = [
            'ValueFacet',
        ];
        try {
            foreach ($properties as $property) {
                if (isset($this->{$property})) {
                    throw new \InvalidArgumentException(sprintf('The property RangeFacet can\'t be set as the property %s is already set. Only one property must be set among these properties: RangeFacet, %s.', $property, implode(', ', $properties)), __LINE__);
                }
            }
        } catch (\InvalidArgumentException $e) {
            $message = $e->getMessage();
        }
        return $message;
    }
    /**
     * Set RangeFacet value
     * This property belongs to a choice that allows only one property to exist. It is
     * therefore removable from the request, consequently if the value assigned to this
     * property is null, the property is removed from this object
     * @throws \InvalidArgumentException
     * @param \Pixelboxx\StructType\RangeFacetType $rangeFacet
     * @return \Pixelboxx\StructType\FacetType
     */
    public function setRangeFacet(\Pixelboxx\StructType\RangeFacetType $rangeFacet = null)
    {
        // validation for constraint: choice(ValueFacet, RangeFacet)
        if ('' !== ($rangeFacetChoiceErrorMessage = self::validateRangeFacetForChoiceConstraintsFromSetRangeFacet($rangeFacet))) {
            throw new \InvalidArgumentException($rangeFacetChoiceErrorMessage, __LINE__);
        }
        if (is_null($rangeFacet) || (is_array($rangeFacet) && empty($rangeFacet))) {
            unset($this->RangeFacet);
        } else {
            $this->RangeFacet = $rangeFacet;
        }
        return $this;
    }
}
