<?php

namespace Pixelboxx\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GetTypeInfoResponse StructType
 * @subpackage Structs
 */
class GetTypeInfoResponse extends AbstractStructBase
{
    /**
     * The Type
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \Pixelboxx\StructType\TypeInfoType[]
     */
    public $Type;
    /**
     * Constructor method for GetTypeInfoResponse
     * @uses GetTypeInfoResponse::setType()
     * @param \Pixelboxx\StructType\TypeInfoType[] $type
     */
    public function __construct(array $type = array())
    {
        $this
            ->setType($type);
    }
    /**
     * Get Type value
     * @return \Pixelboxx\StructType\TypeInfoType[]|null
     */
    public function getType()
    {
        return $this->Type;
    }
    /**
     * This method is responsible for validating the values passed to the setType method
     * This method is willingly generated in order to preserve the one-line inline validation within the setType method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateTypeForArrayConstraintsFromSetType(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $getTypeInfoResponseTypeItem) {
            // validation for constraint: itemType
            if (!$getTypeInfoResponseTypeItem instanceof \Pixelboxx\StructType\TypeInfoType) {
                $invalidValues[] = is_object($getTypeInfoResponseTypeItem) ? get_class($getTypeInfoResponseTypeItem) : sprintf('%s(%s)', gettype($getTypeInfoResponseTypeItem), var_export($getTypeInfoResponseTypeItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The Type property can only contain items of type \Pixelboxx\StructType\TypeInfoType, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set Type value
     * @throws \InvalidArgumentException
     * @param \Pixelboxx\StructType\TypeInfoType[] $type
     * @return \Pixelboxx\StructType\GetTypeInfoResponse
     */
    public function setType(array $type = array())
    {
        // validation for constraint: array
        if ('' !== ($typeArrayErrorMessage = self::validateTypeForArrayConstraintsFromSetType($type))) {
            throw new \InvalidArgumentException($typeArrayErrorMessage, __LINE__);
        }
        $this->Type = $type;
        return $this;
    }
    /**
     * Add item to Type value
     * @throws \InvalidArgumentException
     * @param \Pixelboxx\StructType\TypeInfoType $item
     * @return \Pixelboxx\StructType\GetTypeInfoResponse
     */
    public function addToType(\Pixelboxx\StructType\TypeInfoType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \Pixelboxx\StructType\TypeInfoType) {
            throw new \InvalidArgumentException(sprintf('The Type property can only contain items of type \Pixelboxx\StructType\TypeInfoType, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->Type[] = $item;
        return $this;
    }
}
