<?php

namespace Pixelboxx\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ObjectType StructType
 * Meta information extracted from the WSDL
 * - documentation: Einfaches Objekt. Kann Rohdaten (z.B. Bild) enthalten.
 * @subpackage Structs
 */
class ObjectType extends AbstractObjectType
{
    /**
     * The RawDataList
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \Pixelboxx\StructType\RawDataListType
     */
    public $RawDataList;
    /**
     * The XLinks
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \Pixelboxx\StructType\XLinkListObjectsType
     */
    public $XLinks;
    /**
     * Constructor method for ObjectType
     * @uses ObjectType::setRawDataList()
     * @uses ObjectType::setXLinks()
     * @param \Pixelboxx\StructType\RawDataListType $rawDataList
     * @param \Pixelboxx\StructType\XLinkListObjectsType $xLinks
     */
    public function __construct(\Pixelboxx\StructType\RawDataListType $rawDataList = null, \Pixelboxx\StructType\XLinkListObjectsType $xLinks = null)
    {
        $this
            ->setRawDataList($rawDataList)
            ->setXLinks($xLinks);
    }
    /**
     * Get RawDataList value
     * @return \Pixelboxx\StructType\RawDataListType|null
     */
    public function getRawDataList()
    {
        return $this->RawDataList;
    }
    /**
     * Set RawDataList value
     * @param \Pixelboxx\StructType\RawDataListType $rawDataList
     * @return \Pixelboxx\StructType\ObjectType
     */
    public function setRawDataList(\Pixelboxx\StructType\RawDataListType $rawDataList = null)
    {
        $this->RawDataList = $rawDataList;
        return $this;
    }
    /**
     * Get XLinks value
     * @return \Pixelboxx\StructType\XLinkListObjectsType|null
     */
    public function getXLinks()
    {
        return $this->XLinks;
    }
    /**
     * Set XLinks value
     * @param \Pixelboxx\StructType\XLinkListObjectsType $xLinks
     * @return \Pixelboxx\StructType\ObjectType
     */
    public function setXLinks(\Pixelboxx\StructType\XLinkListObjectsType $xLinks = null)
    {
        $this->XLinks = $xLinks;
        return $this;
    }
}
