<?php

namespace Pixelboxx\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for OrderAttributesType StructType
 * Meta information extracted from the WSDL
 * - documentation: Eine Liste von Attributen nach denen sortiert werden soll. Dieses Element überschreibt das Element "Order"
 * @subpackage Structs
 */
class OrderAttributesType extends AbstractStructBase
{
    /**
     * The OrderAttribute
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 1
     * @var \Pixelboxx\StructType\OrderAttributeType[]
     */
    public $OrderAttribute;
    /**
     * Constructor method for OrderAttributesType
     * @uses OrderAttributesType::setOrderAttribute()
     * @param \Pixelboxx\StructType\OrderAttributeType[] $orderAttribute
     */
    public function __construct(array $orderAttribute = array())
    {
        $this
            ->setOrderAttribute($orderAttribute);
    }
    /**
     * Get OrderAttribute value
     * @return \Pixelboxx\StructType\OrderAttributeType[]
     */
    public function getOrderAttribute()
    {
        return $this->OrderAttribute;
    }
    /**
     * This method is responsible for validating the values passed to the setOrderAttribute method
     * This method is willingly generated in order to preserve the one-line inline validation within the setOrderAttribute method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateOrderAttributeForArrayConstraintsFromSetOrderAttribute(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $orderAttributesTypeOrderAttributeItem) {
            // validation for constraint: itemType
            if (!$orderAttributesTypeOrderAttributeItem instanceof \Pixelboxx\StructType\OrderAttributeType) {
                $invalidValues[] = is_object($orderAttributesTypeOrderAttributeItem) ? get_class($orderAttributesTypeOrderAttributeItem) : sprintf('%s(%s)', gettype($orderAttributesTypeOrderAttributeItem), var_export($orderAttributesTypeOrderAttributeItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The OrderAttribute property can only contain items of type \Pixelboxx\StructType\OrderAttributeType, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set OrderAttribute value
     * @throws \InvalidArgumentException
     * @param \Pixelboxx\StructType\OrderAttributeType[] $orderAttribute
     * @return \Pixelboxx\StructType\OrderAttributesType
     */
    public function setOrderAttribute(array $orderAttribute = array())
    {
        // validation for constraint: array
        if ('' !== ($orderAttributeArrayErrorMessage = self::validateOrderAttributeForArrayConstraintsFromSetOrderAttribute($orderAttribute))) {
            throw new \InvalidArgumentException($orderAttributeArrayErrorMessage, __LINE__);
        }
        $this->OrderAttribute = $orderAttribute;
        return $this;
    }
    /**
     * Add item to OrderAttribute value
     * @throws \InvalidArgumentException
     * @param \Pixelboxx\StructType\OrderAttributeType $item
     * @return \Pixelboxx\StructType\OrderAttributesType
     */
    public function addToOrderAttribute(\Pixelboxx\StructType\OrderAttributeType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \Pixelboxx\StructType\OrderAttributeType) {
            throw new \InvalidArgumentException(sprintf('The OrderAttribute property can only contain items of type \Pixelboxx\StructType\OrderAttributeType, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->OrderAttribute[] = $item;
        return $this;
    }
}
