<?php

namespace Pixelboxx\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for RawDataListType StructType
 * Meta information extracted from the WSDL
 * - documentation: Liste von Rohdaten.
 * @subpackage Structs
 */
class RawDataListType extends AbstractStructBase
{
    /**
     * The RawData
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \Pixelboxx\StructType\RawDataType[]
     */
    public $RawData;
    /**
     * Constructor method for RawDataListType
     * @uses RawDataListType::setRawData()
     * @param \Pixelboxx\StructType\RawDataType[] $rawData
     */
    public function __construct(array $rawData = array())
    {
        $this
            ->setRawData($rawData);
    }
    /**
     * Get RawData value
     * @return \Pixelboxx\StructType\RawDataType[]|null
     */
    public function getRawData()
    {
        return $this->RawData;
    }
    /**
     * This method is responsible for validating the values passed to the setRawData method
     * This method is willingly generated in order to preserve the one-line inline validation within the setRawData method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateRawDataForArrayConstraintsFromSetRawData(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $rawDataListTypeRawDataItem) {
            // validation for constraint: itemType
            if (!$rawDataListTypeRawDataItem instanceof \Pixelboxx\StructType\RawDataType) {
                $invalidValues[] = is_object($rawDataListTypeRawDataItem) ? get_class($rawDataListTypeRawDataItem) : sprintf('%s(%s)', gettype($rawDataListTypeRawDataItem), var_export($rawDataListTypeRawDataItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The RawData property can only contain items of type \Pixelboxx\StructType\RawDataType, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set RawData value
     * @throws \InvalidArgumentException
     * @param \Pixelboxx\StructType\RawDataType[] $rawData
     * @return \Pixelboxx\StructType\RawDataListType
     */
    public function setRawData(array $rawData = array())
    {
        // validation for constraint: array
        if ('' !== ($rawDataArrayErrorMessage = self::validateRawDataForArrayConstraintsFromSetRawData($rawData))) {
            throw new \InvalidArgumentException($rawDataArrayErrorMessage, __LINE__);
        }
        $this->RawData = $rawData;
        return $this;
    }
    /**
     * Add item to RawData value
     * @throws \InvalidArgumentException
     * @param \Pixelboxx\StructType\RawDataType $item
     * @return \Pixelboxx\StructType\RawDataListType
     */
    public function addToRawData(\Pixelboxx\StructType\RawDataType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \Pixelboxx\StructType\RawDataType) {
            throw new \InvalidArgumentException(sprintf('The RawData property can only contain items of type \Pixelboxx\StructType\RawDataType, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->RawData[] = $item;
        return $this;
    }
}
