<?php

namespace Pixelboxx\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for SearchStringType StructType
 * Meta information extracted from the WSDL
 * - documentation: Suche nach einem String. Dabei ist "op" der Suchoperator und der Elementwert der Wert, mit dem verglichen werden soll. Der Attributwert steht links vom Operator, der Vergleichswert rechts davon.
 * @subpackage Structs
 */
class SearchStringType extends AbstractStructBase
{
    /**
     * The _
     * @var string
     */
    public $_;
    /**
     * The op
     * Meta information extracted from the WSDL
     * - default: eq
     * - use: optional
     * @var string
     */
    public $op;
    /**
     * Constructor method for SearchStringType
     * @uses SearchStringType::set_()
     * @uses SearchStringType::setOp()
     * @param string $_
     * @param string $op
     */
    public function __construct($_ = null, $op = 'eq')
    {
        $this
            ->set_($_)
            ->setOp($op);
    }
    /**
     * Get _ value
     * @return string|null
     */
    public function get_()
    {
        return $this->_;
    }
    /**
     * Set _ value
     * @param string $_
     * @return \Pixelboxx\StructType\SearchStringType
     */
    public function set_($_ = null)
    {
        // validation for constraint: string
        if (!is_null($_) && !is_string($_)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($_, true), gettype($_)), __LINE__);
        }
        $this->_ = $_;
        return $this;
    }
    /**
     * Get op value
     * @return string|null
     */
    public function getOp()
    {
        return $this->op;
    }
    /**
     * Set op value
     * @uses \Pixelboxx\EnumType\SearchOpType::valueIsValid()
     * @uses \Pixelboxx\EnumType\SearchOpType::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $op
     * @return \Pixelboxx\StructType\SearchStringType
     */
    public function setOp($op = 'eq')
    {
        // validation for constraint: enumeration
        if (!\Pixelboxx\EnumType\SearchOpType::valueIsValid($op)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \Pixelboxx\EnumType\SearchOpType', is_array($op) ? implode(', ', $op) : var_export($op, true), implode(', ', \Pixelboxx\EnumType\SearchOpType::getValidValues())), __LINE__);
        }
        $this->op = $op;
        return $this;
    }
}
