<?php

namespace Pixelboxx\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for SearchTerm StructType
 * @subpackage Structs
 */
class SearchTerm extends AbstractStructBase
{
    /**
     * The AndTerm
     * Meta information extracted from the WSDL
     * - choice: AndTerm | OrTerm | NotTerm | AttributeTerm | StringTerm | XLinkTerm | InFolderTerm | SolrQueryTerm
     * - choiceMaxOccurs: 1
     * - choiceMinOccurs: 1
     * - ref: pb:AndTerm
     * @var \Pixelboxx\StructType\AndTerm
     */
    public $AndTerm;
    /**
     * The OrTerm
     * Meta information extracted from the WSDL
     * - choice: AndTerm | OrTerm | NotTerm | AttributeTerm | StringTerm | XLinkTerm | InFolderTerm | SolrQueryTerm
     * - choiceMaxOccurs: 1
     * - choiceMinOccurs: 1
     * - ref: pb:OrTerm
     * @var \Pixelboxx\StructType\OrTerm
     */
    public $OrTerm;
    /**
     * The NotTerm
     * Meta information extracted from the WSDL
     * - choice: AndTerm | OrTerm | NotTerm | AttributeTerm | StringTerm | XLinkTerm | InFolderTerm | SolrQueryTerm
     * - choiceMaxOccurs: 1
     * - choiceMinOccurs: 1
     * - ref: pb:NotTerm
     * @var \Pixelboxx\StructType\NotTerm
     */
    public $NotTerm;
    /**
     * The AttributeTerm
     * Meta information extracted from the WSDL
     * - choice: AndTerm | OrTerm | NotTerm | AttributeTerm | StringTerm | XLinkTerm | InFolderTerm | SolrQueryTerm
     * - choiceMaxOccurs: 1
     * - choiceMinOccurs: 1
     * - ref: pb:AttributeTerm
     * @var \Pixelboxx\StructType\SearchAttributeType
     */
    public $AttributeTerm;
    /**
     * The StringTerm
     * Meta information extracted from the WSDL
     * - choice: AndTerm | OrTerm | NotTerm | AttributeTerm | StringTerm | XLinkTerm | InFolderTerm | SolrQueryTerm
     * - choiceMaxOccurs: 1
     * - choiceMinOccurs: 1
     * - ref: pb:StringTerm
     * @var \Pixelboxx\StructType\SearchStringType
     */
    public $StringTerm;
    /**
     * The XLinkTerm
     * Meta information extracted from the WSDL
     * - choice: AndTerm | OrTerm | NotTerm | AttributeTerm | StringTerm | XLinkTerm | InFolderTerm | SolrQueryTerm
     * - choiceMaxOccurs: 1
     * - choiceMinOccurs: 1
     * - ref: pb:XLinkTerm
     * @var \Pixelboxx\StructType\SearchXLinkType
     */
    public $XLinkTerm;
    /**
     * The InFolderTerm
     * Meta information extracted from the WSDL
     * - choice: AndTerm | OrTerm | NotTerm | AttributeTerm | StringTerm | XLinkTerm | InFolderTerm | SolrQueryTerm
     * - choiceMaxOccurs: 1
     * - choiceMinOccurs: 1
     * - ref: pb:InFolderTerm
     * @var \Pixelboxx\StructType\SearchInFolderType
     */
    public $InFolderTerm;
    /**
     * The SolrQueryTerm
     * Meta information extracted from the WSDL
     * - choice: AndTerm | OrTerm | NotTerm | AttributeTerm | StringTerm | XLinkTerm | InFolderTerm | SolrQueryTerm
     * - choiceMaxOccurs: 1
     * - choiceMinOccurs: 1
     * - ref: pb:SolrQueryTerm
     * @var \Pixelboxx\StructType\SolrQueryTermType
     */
    public $SolrQueryTerm;
    /**
     * Constructor method for SearchTerm
     * @uses SearchTerm::setAndTerm()
     * @uses SearchTerm::setOrTerm()
     * @uses SearchTerm::setNotTerm()
     * @uses SearchTerm::setAttributeTerm()
     * @uses SearchTerm::setStringTerm()
     * @uses SearchTerm::setXLinkTerm()
     * @uses SearchTerm::setInFolderTerm()
     * @uses SearchTerm::setSolrQueryTerm()
     * @param \Pixelboxx\StructType\AndTerm $andTerm
     * @param \Pixelboxx\StructType\OrTerm $orTerm
     * @param \Pixelboxx\StructType\NotTerm $notTerm
     * @param \Pixelboxx\StructType\SearchAttributeType $attributeTerm
     * @param \Pixelboxx\StructType\SearchStringType $stringTerm
     * @param \Pixelboxx\StructType\SearchXLinkType $xLinkTerm
     * @param \Pixelboxx\StructType\SearchInFolderType $inFolderTerm
     * @param \Pixelboxx\StructType\SolrQueryTermType $solrQueryTerm
     */
    public function __construct(\Pixelboxx\StructType\AndTerm $andTerm = null, \Pixelboxx\StructType\OrTerm $orTerm = null, \Pixelboxx\StructType\NotTerm $notTerm = null, \Pixelboxx\StructType\SearchAttributeType $attributeTerm = null, \Pixelboxx\StructType\SearchStringType $stringTerm = null, \Pixelboxx\StructType\SearchXLinkType $xLinkTerm = null, \Pixelboxx\StructType\SearchInFolderType $inFolderTerm = null, \Pixelboxx\StructType\SolrQueryTermType $solrQueryTerm = null)
    {
        $this
            ->setAndTerm($andTerm)
            ->setOrTerm($orTerm)
            ->setNotTerm($notTerm)
            ->setAttributeTerm($attributeTerm)
            ->setStringTerm($stringTerm)
            ->setXLinkTerm($xLinkTerm)
            ->setInFolderTerm($inFolderTerm)
            ->setSolrQueryTerm($solrQueryTerm);
    }
    /**
     * Get AndTerm value
     * @return \Pixelboxx\StructType\AndTerm|null
     */
    public function getAndTerm()
    {
        return isset($this->AndTerm) ? $this->AndTerm : null;
    }
    /**
     * This method is responsible for validating the value passed to the setAndTerm method
     * This method is willingly generated in order to preserve the one-line inline validation within the setAndTerm method
     * This has to validate that the property which is being set is the only one among the given choices
     * @param mixed $value
     * @return string A non-empty message if the values does not match the validation rules
     */
    public function validateAndTermForChoiceConstraintsFromSetAndTerm($value)
    {
        $message = '';
        if (is_null($value)) {
            return $message;
        }
        $properties = [
            'OrTerm',
            'NotTerm',
            'AttributeTerm',
            'StringTerm',
            'XLinkTerm',
            'InFolderTerm',
            'SolrQueryTerm',
        ];
        try {
            foreach ($properties as $property) {
                if (isset($this->{$property})) {
                    throw new \InvalidArgumentException(sprintf('The property AndTerm can\'t be set as the property %s is already set. Only one property must be set among these properties: AndTerm, %s.', $property, implode(', ', $properties)), __LINE__);
                }
            }
        } catch (\InvalidArgumentException $e) {
            $message = $e->getMessage();
        }
        return $message;
    }
    /**
     * Set AndTerm value
     * This property belongs to a choice that allows only one property to exist. It is
     * therefore removable from the request, consequently if the value assigned to this
     * property is null, the property is removed from this object
     * @throws \InvalidArgumentException
     * @param \Pixelboxx\StructType\AndTerm $andTerm
     * @return \Pixelboxx\StructType\SearchTerm
     */
    public function setAndTerm(\Pixelboxx\StructType\AndTerm $andTerm = null)
    {
        // validation for constraint: choice(AndTerm, OrTerm, NotTerm, AttributeTerm, StringTerm, XLinkTerm, InFolderTerm, SolrQueryTerm)
        if ('' !== ($andTermChoiceErrorMessage = self::validateAndTermForChoiceConstraintsFromSetAndTerm($andTerm))) {
            throw new \InvalidArgumentException($andTermChoiceErrorMessage, __LINE__);
        }
        if (is_null($andTerm) || (is_array($andTerm) && empty($andTerm))) {
            unset($this->AndTerm);
        } else {
            $this->AndTerm = $andTerm;
        }
        return $this;
    }
    /**
     * Get OrTerm value
     * @return \Pixelboxx\StructType\OrTerm|null
     */
    public function getOrTerm()
    {
        return isset($this->OrTerm) ? $this->OrTerm : null;
    }
    /**
     * This method is responsible for validating the value passed to the setOrTerm method
     * This method is willingly generated in order to preserve the one-line inline validation within the setOrTerm method
     * This has to validate that the property which is being set is the only one among the given choices
     * @param mixed $value
     * @return string A non-empty message if the values does not match the validation rules
     */
    public function validateOrTermForChoiceConstraintsFromSetOrTerm($value)
    {
        $message = '';
        if (is_null($value)) {
            return $message;
        }
        $properties = [
            'AndTerm',
            'NotTerm',
            'AttributeTerm',
            'StringTerm',
            'XLinkTerm',
            'InFolderTerm',
            'SolrQueryTerm',
        ];
        try {
            foreach ($properties as $property) {
                if (isset($this->{$property})) {
                    throw new \InvalidArgumentException(sprintf('The property OrTerm can\'t be set as the property %s is already set. Only one property must be set among these properties: OrTerm, %s.', $property, implode(', ', $properties)), __LINE__);
                }
            }
        } catch (\InvalidArgumentException $e) {
            $message = $e->getMessage();
        }
        return $message;
    }
    /**
     * Set OrTerm value
     * This property belongs to a choice that allows only one property to exist. It is
     * therefore removable from the request, consequently if the value assigned to this
     * property is null, the property is removed from this object
     * @throws \InvalidArgumentException
     * @param \Pixelboxx\StructType\OrTerm $orTerm
     * @return \Pixelboxx\StructType\SearchTerm
     */
    public function setOrTerm(\Pixelboxx\StructType\OrTerm $orTerm = null)
    {
        // validation for constraint: choice(AndTerm, OrTerm, NotTerm, AttributeTerm, StringTerm, XLinkTerm, InFolderTerm, SolrQueryTerm)
        if ('' !== ($orTermChoiceErrorMessage = self::validateOrTermForChoiceConstraintsFromSetOrTerm($orTerm))) {
            throw new \InvalidArgumentException($orTermChoiceErrorMessage, __LINE__);
        }
        if (is_null($orTerm) || (is_array($orTerm) && empty($orTerm))) {
            unset($this->OrTerm);
        } else {
            $this->OrTerm = $orTerm;
        }
        return $this;
    }
    /**
     * Get NotTerm value
     * @return \Pixelboxx\StructType\NotTerm|null
     */
    public function getNotTerm()
    {
        return isset($this->NotTerm) ? $this->NotTerm : null;
    }
    /**
     * This method is responsible for validating the value passed to the setNotTerm method
     * This method is willingly generated in order to preserve the one-line inline validation within the setNotTerm method
     * This has to validate that the property which is being set is the only one among the given choices
     * @param mixed $value
     * @return string A non-empty message if the values does not match the validation rules
     */
    public function validateNotTermForChoiceConstraintsFromSetNotTerm($value)
    {
        $message = '';
        if (is_null($value)) {
            return $message;
        }
        $properties = [
            'AndTerm',
            'OrTerm',
            'AttributeTerm',
            'StringTerm',
            'XLinkTerm',
            'InFolderTerm',
            'SolrQueryTerm',
        ];
        try {
            foreach ($properties as $property) {
                if (isset($this->{$property})) {
                    throw new \InvalidArgumentException(sprintf('The property NotTerm can\'t be set as the property %s is already set. Only one property must be set among these properties: NotTerm, %s.', $property, implode(', ', $properties)), __LINE__);
                }
            }
        } catch (\InvalidArgumentException $e) {
            $message = $e->getMessage();
        }
        return $message;
    }
    /**
     * Set NotTerm value
     * This property belongs to a choice that allows only one property to exist. It is
     * therefore removable from the request, consequently if the value assigned to this
     * property is null, the property is removed from this object
     * @throws \InvalidArgumentException
     * @param \Pixelboxx\StructType\NotTerm $notTerm
     * @return \Pixelboxx\StructType\SearchTerm
     */
    public function setNotTerm(\Pixelboxx\StructType\NotTerm $notTerm = null)
    {
        // validation for constraint: choice(AndTerm, OrTerm, NotTerm, AttributeTerm, StringTerm, XLinkTerm, InFolderTerm, SolrQueryTerm)
        if ('' !== ($notTermChoiceErrorMessage = self::validateNotTermForChoiceConstraintsFromSetNotTerm($notTerm))) {
            throw new \InvalidArgumentException($notTermChoiceErrorMessage, __LINE__);
        }
        if (is_null($notTerm) || (is_array($notTerm) && empty($notTerm))) {
            unset($this->NotTerm);
        } else {
            $this->NotTerm = $notTerm;
        }
        return $this;
    }
    /**
     * Get AttributeTerm value
     * @return \Pixelboxx\StructType\SearchAttributeType|null
     */
    public function getAttributeTerm()
    {
        return isset($this->AttributeTerm) ? $this->AttributeTerm : null;
    }
    /**
     * This method is responsible for validating the value passed to the setAttributeTerm method
     * This method is willingly generated in order to preserve the one-line inline validation within the setAttributeTerm method
     * This has to validate that the property which is being set is the only one among the given choices
     * @param mixed $value
     * @return string A non-empty message if the values does not match the validation rules
     */
    public function validateAttributeTermForChoiceConstraintsFromSetAttributeTerm($value)
    {
        $message = '';
        if (is_null($value)) {
            return $message;
        }
        $properties = [
            'AndTerm',
            'OrTerm',
            'NotTerm',
            'StringTerm',
            'XLinkTerm',
            'InFolderTerm',
            'SolrQueryTerm',
        ];
        try {
            foreach ($properties as $property) {
                if (isset($this->{$property})) {
                    throw new \InvalidArgumentException(sprintf('The property AttributeTerm can\'t be set as the property %s is already set. Only one property must be set among these properties: AttributeTerm, %s.', $property, implode(', ', $properties)), __LINE__);
                }
            }
        } catch (\InvalidArgumentException $e) {
            $message = $e->getMessage();
        }
        return $message;
    }
    /**
     * Set AttributeTerm value
     * This property belongs to a choice that allows only one property to exist. It is
     * therefore removable from the request, consequently if the value assigned to this
     * property is null, the property is removed from this object
     * @throws \InvalidArgumentException
     * @param \Pixelboxx\StructType\SearchAttributeType $attributeTerm
     * @return \Pixelboxx\StructType\SearchTerm
     */
    public function setAttributeTerm(\Pixelboxx\StructType\SearchAttributeType $attributeTerm = null)
    {
        // validation for constraint: choice(AndTerm, OrTerm, NotTerm, AttributeTerm, StringTerm, XLinkTerm, InFolderTerm, SolrQueryTerm)
        if ('' !== ($attributeTermChoiceErrorMessage = self::validateAttributeTermForChoiceConstraintsFromSetAttributeTerm($attributeTerm))) {
            throw new \InvalidArgumentException($attributeTermChoiceErrorMessage, __LINE__);
        }
        if (is_null($attributeTerm) || (is_array($attributeTerm) && empty($attributeTerm))) {
            unset($this->AttributeTerm);
        } else {
            $this->AttributeTerm = $attributeTerm;
        }
        return $this;
    }
    /**
     * Get StringTerm value
     * @return \Pixelboxx\StructType\SearchStringType|null
     */
    public function getStringTerm()
    {
        return isset($this->StringTerm) ? $this->StringTerm : null;
    }
    /**
     * This method is responsible for validating the value passed to the setStringTerm method
     * This method is willingly generated in order to preserve the one-line inline validation within the setStringTerm method
     * This has to validate that the property which is being set is the only one among the given choices
     * @param mixed $value
     * @return string A non-empty message if the values does not match the validation rules
     */
    public function validateStringTermForChoiceConstraintsFromSetStringTerm($value)
    {
        $message = '';
        if (is_null($value)) {
            return $message;
        }
        $properties = [
            'AndTerm',
            'OrTerm',
            'NotTerm',
            'AttributeTerm',
            'XLinkTerm',
            'InFolderTerm',
            'SolrQueryTerm',
        ];
        try {
            foreach ($properties as $property) {
                if (isset($this->{$property})) {
                    throw new \InvalidArgumentException(sprintf('The property StringTerm can\'t be set as the property %s is already set. Only one property must be set among these properties: StringTerm, %s.', $property, implode(', ', $properties)), __LINE__);
                }
            }
        } catch (\InvalidArgumentException $e) {
            $message = $e->getMessage();
        }
        return $message;
    }
    /**
     * Set StringTerm value
     * This property belongs to a choice that allows only one property to exist. It is
     * therefore removable from the request, consequently if the value assigned to this
     * property is null, the property is removed from this object
     * @throws \InvalidArgumentException
     * @param \Pixelboxx\StructType\SearchStringType $stringTerm
     * @return \Pixelboxx\StructType\SearchTerm
     */
    public function setStringTerm(\Pixelboxx\StructType\SearchStringType $stringTerm = null)
    {
        // validation for constraint: choice(AndTerm, OrTerm, NotTerm, AttributeTerm, StringTerm, XLinkTerm, InFolderTerm, SolrQueryTerm)
        if ('' !== ($stringTermChoiceErrorMessage = self::validateStringTermForChoiceConstraintsFromSetStringTerm($stringTerm))) {
            throw new \InvalidArgumentException($stringTermChoiceErrorMessage, __LINE__);
        }
        if (is_null($stringTerm) || (is_array($stringTerm) && empty($stringTerm))) {
            unset($this->StringTerm);
        } else {
            $this->StringTerm = $stringTerm;
        }
        return $this;
    }
    /**
     * Get XLinkTerm value
     * @return \Pixelboxx\StructType\SearchXLinkType|null
     */
    public function getXLinkTerm()
    {
        return isset($this->XLinkTerm) ? $this->XLinkTerm : null;
    }
    /**
     * This method is responsible for validating the value passed to the setXLinkTerm method
     * This method is willingly generated in order to preserve the one-line inline validation within the setXLinkTerm method
     * This has to validate that the property which is being set is the only one among the given choices
     * @param mixed $value
     * @return string A non-empty message if the values does not match the validation rules
     */
    public function validateXLinkTermForChoiceConstraintsFromSetXLinkTerm($value)
    {
        $message = '';
        if (is_null($value)) {
            return $message;
        }
        $properties = [
            'AndTerm',
            'OrTerm',
            'NotTerm',
            'AttributeTerm',
            'StringTerm',
            'InFolderTerm',
            'SolrQueryTerm',
        ];
        try {
            foreach ($properties as $property) {
                if (isset($this->{$property})) {
                    throw new \InvalidArgumentException(sprintf('The property XLinkTerm can\'t be set as the property %s is already set. Only one property must be set among these properties: XLinkTerm, %s.', $property, implode(', ', $properties)), __LINE__);
                }
            }
        } catch (\InvalidArgumentException $e) {
            $message = $e->getMessage();
        }
        return $message;
    }
    /**
     * Set XLinkTerm value
     * This property belongs to a choice that allows only one property to exist. It is
     * therefore removable from the request, consequently if the value assigned to this
     * property is null, the property is removed from this object
     * @throws \InvalidArgumentException
     * @param \Pixelboxx\StructType\SearchXLinkType $xLinkTerm
     * @return \Pixelboxx\StructType\SearchTerm
     */
    public function setXLinkTerm(\Pixelboxx\StructType\SearchXLinkType $xLinkTerm = null)
    {
        // validation for constraint: choice(AndTerm, OrTerm, NotTerm, AttributeTerm, StringTerm, XLinkTerm, InFolderTerm, SolrQueryTerm)
        if ('' !== ($xLinkTermChoiceErrorMessage = self::validateXLinkTermForChoiceConstraintsFromSetXLinkTerm($xLinkTerm))) {
            throw new \InvalidArgumentException($xLinkTermChoiceErrorMessage, __LINE__);
        }
        if (is_null($xLinkTerm) || (is_array($xLinkTerm) && empty($xLinkTerm))) {
            unset($this->XLinkTerm);
        } else {
            $this->XLinkTerm = $xLinkTerm;
        }
        return $this;
    }
    /**
     * Get InFolderTerm value
     * @return \Pixelboxx\StructType\SearchInFolderType|null
     */
    public function getInFolderTerm()
    {
        return isset($this->InFolderTerm) ? $this->InFolderTerm : null;
    }
    /**
     * This method is responsible for validating the value passed to the setInFolderTerm method
     * This method is willingly generated in order to preserve the one-line inline validation within the setInFolderTerm method
     * This has to validate that the property which is being set is the only one among the given choices
     * @param mixed $value
     * @return string A non-empty message if the values does not match the validation rules
     */
    public function validateInFolderTermForChoiceConstraintsFromSetInFolderTerm($value)
    {
        $message = '';
        if (is_null($value)) {
            return $message;
        }
        $properties = [
            'AndTerm',
            'OrTerm',
            'NotTerm',
            'AttributeTerm',
            'StringTerm',
            'XLinkTerm',
            'SolrQueryTerm',
        ];
        try {
            foreach ($properties as $property) {
                if (isset($this->{$property})) {
                    throw new \InvalidArgumentException(sprintf('The property InFolderTerm can\'t be set as the property %s is already set. Only one property must be set among these properties: InFolderTerm, %s.', $property, implode(', ', $properties)), __LINE__);
                }
            }
        } catch (\InvalidArgumentException $e) {
            $message = $e->getMessage();
        }
        return $message;
    }
    /**
     * Set InFolderTerm value
     * This property belongs to a choice that allows only one property to exist. It is
     * therefore removable from the request, consequently if the value assigned to this
     * property is null, the property is removed from this object
     * @throws \InvalidArgumentException
     * @param \Pixelboxx\StructType\SearchInFolderType $inFolderTerm
     * @return \Pixelboxx\StructType\SearchTerm
     */
    public function setInFolderTerm(\Pixelboxx\StructType\SearchInFolderType $inFolderTerm = null)
    {
        // validation for constraint: choice(AndTerm, OrTerm, NotTerm, AttributeTerm, StringTerm, XLinkTerm, InFolderTerm, SolrQueryTerm)
        if ('' !== ($inFolderTermChoiceErrorMessage = self::validateInFolderTermForChoiceConstraintsFromSetInFolderTerm($inFolderTerm))) {
            throw new \InvalidArgumentException($inFolderTermChoiceErrorMessage, __LINE__);
        }
        if (is_null($inFolderTerm) || (is_array($inFolderTerm) && empty($inFolderTerm))) {
            unset($this->InFolderTerm);
        } else {
            $this->InFolderTerm = $inFolderTerm;
        }
        return $this;
    }
    /**
     * Get SolrQueryTerm value
     * @return \Pixelboxx\StructType\SolrQueryTermType|null
     */
    public function getSolrQueryTerm()
    {
        return isset($this->SolrQueryTerm) ? $this->SolrQueryTerm : null;
    }
    /**
     * This method is responsible for validating the value passed to the setSolrQueryTerm method
     * This method is willingly generated in order to preserve the one-line inline validation within the setSolrQueryTerm method
     * This has to validate that the property which is being set is the only one among the given choices
     * @param mixed $value
     * @return string A non-empty message if the values does not match the validation rules
     */
    public function validateSolrQueryTermForChoiceConstraintsFromSetSolrQueryTerm($value)
    {
        $message = '';
        if (is_null($value)) {
            return $message;
        }
        $properties = [
            'AndTerm',
            'OrTerm',
            'NotTerm',
            'AttributeTerm',
            'StringTerm',
            'XLinkTerm',
            'InFolderTerm',
        ];
        try {
            foreach ($properties as $property) {
                if (isset($this->{$property})) {
                    throw new \InvalidArgumentException(sprintf('The property SolrQueryTerm can\'t be set as the property %s is already set. Only one property must be set among these properties: SolrQueryTerm, %s.', $property, implode(', ', $properties)), __LINE__);
                }
            }
        } catch (\InvalidArgumentException $e) {
            $message = $e->getMessage();
        }
        return $message;
    }
    /**
     * Set SolrQueryTerm value
     * This property belongs to a choice that allows only one property to exist. It is
     * therefore removable from the request, consequently if the value assigned to this
     * property is null, the property is removed from this object
     * @throws \InvalidArgumentException
     * @param \Pixelboxx\StructType\SolrQueryTermType $solrQueryTerm
     * @return \Pixelboxx\StructType\SearchTerm
     */
    public function setSolrQueryTerm(\Pixelboxx\StructType\SolrQueryTermType $solrQueryTerm = null)
    {
        // validation for constraint: choice(AndTerm, OrTerm, NotTerm, AttributeTerm, StringTerm, XLinkTerm, InFolderTerm, SolrQueryTerm)
        if ('' !== ($solrQueryTermChoiceErrorMessage = self::validateSolrQueryTermForChoiceConstraintsFromSetSolrQueryTerm($solrQueryTerm))) {
            throw new \InvalidArgumentException($solrQueryTermChoiceErrorMessage, __LINE__);
        }
        if (is_null($solrQueryTerm) || (is_array($solrQueryTerm) && empty($solrQueryTerm))) {
            unset($this->SolrQueryTerm);
        } else {
            $this->SolrQueryTerm = $solrQueryTerm;
        }
        return $this;
    }
}
