<?php

namespace Pixelboxx\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for SearchXLinkType StructType
 * @subpackage Structs
 */
class SearchXLinkType extends AbstractStructBase
{
    /**
     * The targetRef
     * Meta information extracted from the WSDL
     * - use: required
     * @var string
     */
    public $targetRef;
    /**
     * The type
     * Meta information extracted from the WSDL
     * - base: xs:token
     * - use: required
     * @var string
     */
    public $type;
    /**
     * The sourceRef
     * Meta information extracted from the WSDL
     * - use: optional
     * @var string
     */
    public $sourceRef;
    /**
     * Constructor method for SearchXLinkType
     * @uses SearchXLinkType::setTargetRef()
     * @uses SearchXLinkType::setType()
     * @uses SearchXLinkType::setSourceRef()
     * @param string $targetRef
     * @param string $type
     * @param string $sourceRef
     */
    public function __construct($targetRef = null, $type = null, $sourceRef = null)
    {
        $this
            ->setTargetRef($targetRef)
            ->setType($type)
            ->setSourceRef($sourceRef);
    }
    /**
     * Get targetRef value
     * @return string
     */
    public function getTargetRef()
    {
        return $this->targetRef;
    }
    /**
     * Set targetRef value
     * @param string $targetRef
     * @return \Pixelboxx\StructType\SearchXLinkType
     */
    public function setTargetRef($targetRef = null)
    {
        // validation for constraint: string
        if (!is_null($targetRef) && !is_string($targetRef)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($targetRef, true), gettype($targetRef)), __LINE__);
        }
        $this->targetRef = $targetRef;
        return $this;
    }
    /**
     * Get type value
     * @return string
     */
    public function getType()
    {
        return $this->type;
    }
    /**
     * Set type value
     * @param string $type
     * @return \Pixelboxx\StructType\SearchXLinkType
     */
    public function setType($type = null)
    {
        // validation for constraint: string
        if (!is_null($type) && !is_string($type)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($type, true), gettype($type)), __LINE__);
        }
        $this->type = $type;
        return $this;
    }
    /**
     * Get sourceRef value
     * @return string|null
     */
    public function getSourceRef()
    {
        return $this->sourceRef;
    }
    /**
     * Set sourceRef value
     * @param string $sourceRef
     * @return \Pixelboxx\StructType\SearchXLinkType
     */
    public function setSourceRef($sourceRef = null)
    {
        // validation for constraint: string
        if (!is_null($sourceRef) && !is_string($sourceRef)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($sourceRef, true), gettype($sourceRef)), __LINE__);
        }
        $this->sourceRef = $sourceRef;
        return $this;
    }
}
