<?php

namespace Pixelboxx\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for UpdateXLinkListType StructType
 * Meta information extracted from the WSDL
 * - documentation: Faßt Verknüpfungen zusammen.
 * @subpackage Structs
 */
class UpdateXLinkListType extends AbstractStructBase
{
    /**
     * The xlinks
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 1
     * @var \Pixelboxx\StructType\UpdateXLinkType[]
     */
    public $xlinks;
    /**
     * Constructor method for UpdateXLinkListType
     * @uses UpdateXLinkListType::setXlinks()
     * @param \Pixelboxx\StructType\UpdateXLinkType[] $xlinks
     */
    public function __construct(array $xlinks = array())
    {
        $this
            ->setXlinks($xlinks);
    }
    /**
     * Get xlinks value
     * @return \Pixelboxx\StructType\UpdateXLinkType[]
     */
    public function getXlinks()
    {
        return $this->xlinks;
    }
    /**
     * This method is responsible for validating the values passed to the setXlinks method
     * This method is willingly generated in order to preserve the one-line inline validation within the setXlinks method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateXlinksForArrayConstraintsFromSetXlinks(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $updateXLinkListTypeXlinksItem) {
            // validation for constraint: itemType
            if (!$updateXLinkListTypeXlinksItem instanceof \Pixelboxx\StructType\UpdateXLinkType) {
                $invalidValues[] = is_object($updateXLinkListTypeXlinksItem) ? get_class($updateXLinkListTypeXlinksItem) : sprintf('%s(%s)', gettype($updateXLinkListTypeXlinksItem), var_export($updateXLinkListTypeXlinksItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The xlinks property can only contain items of type \Pixelboxx\StructType\UpdateXLinkType, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set xlinks value
     * @throws \InvalidArgumentException
     * @param \Pixelboxx\StructType\UpdateXLinkType[] $xlinks
     * @return \Pixelboxx\StructType\UpdateXLinkListType
     */
    public function setXlinks(array $xlinks = array())
    {
        // validation for constraint: array
        if ('' !== ($xlinksArrayErrorMessage = self::validateXlinksForArrayConstraintsFromSetXlinks($xlinks))) {
            throw new \InvalidArgumentException($xlinksArrayErrorMessage, __LINE__);
        }
        $this->xlinks = $xlinks;
        return $this;
    }
    /**
     * Add item to xlinks value
     * @throws \InvalidArgumentException
     * @param \Pixelboxx\StructType\UpdateXLinkType $item
     * @return \Pixelboxx\StructType\UpdateXLinkListType
     */
    public function addToXlinks(\Pixelboxx\StructType\UpdateXLinkType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \Pixelboxx\StructType\UpdateXLinkType) {
            throw new \InvalidArgumentException(sprintf('The xlinks property can only contain items of type \Pixelboxx\StructType\UpdateXLinkType, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->xlinks[] = $item;
        return $this;
    }
}
