<?php

namespace Pixelboxx\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for XLinkListObjectsRequestType StructType
 * @subpackage Structs
 */
class XLinkListObjectsRequestType extends AbstractStructBase
{
    /**
     * The WantedXLinks
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 1
     * @var \Pixelboxx\StructType\XLinkObjectsRequestType[]
     */
    public $WantedXLinks;
    /**
     * Constructor method for XLinkListObjectsRequestType
     * @uses XLinkListObjectsRequestType::setWantedXLinks()
     * @param \Pixelboxx\StructType\XLinkObjectsRequestType[] $wantedXLinks
     */
    public function __construct(array $wantedXLinks = array())
    {
        $this
            ->setWantedXLinks($wantedXLinks);
    }
    /**
     * Get WantedXLinks value
     * @return \Pixelboxx\StructType\XLinkObjectsRequestType[]
     */
    public function getWantedXLinks()
    {
        return $this->WantedXLinks;
    }
    /**
     * This method is responsible for validating the values passed to the setWantedXLinks method
     * This method is willingly generated in order to preserve the one-line inline validation within the setWantedXLinks method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateWantedXLinksForArrayConstraintsFromSetWantedXLinks(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $xLinkListObjectsRequestTypeWantedXLinksItem) {
            // validation for constraint: itemType
            if (!$xLinkListObjectsRequestTypeWantedXLinksItem instanceof \Pixelboxx\StructType\XLinkObjectsRequestType) {
                $invalidValues[] = is_object($xLinkListObjectsRequestTypeWantedXLinksItem) ? get_class($xLinkListObjectsRequestTypeWantedXLinksItem) : sprintf('%s(%s)', gettype($xLinkListObjectsRequestTypeWantedXLinksItem), var_export($xLinkListObjectsRequestTypeWantedXLinksItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The WantedXLinks property can only contain items of type \Pixelboxx\StructType\XLinkObjectsRequestType, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set WantedXLinks value
     * @throws \InvalidArgumentException
     * @param \Pixelboxx\StructType\XLinkObjectsRequestType[] $wantedXLinks
     * @return \Pixelboxx\StructType\XLinkListObjectsRequestType
     */
    public function setWantedXLinks(array $wantedXLinks = array())
    {
        // validation for constraint: array
        if ('' !== ($wantedXLinksArrayErrorMessage = self::validateWantedXLinksForArrayConstraintsFromSetWantedXLinks($wantedXLinks))) {
            throw new \InvalidArgumentException($wantedXLinksArrayErrorMessage, __LINE__);
        }
        $this->WantedXLinks = $wantedXLinks;
        return $this;
    }
    /**
     * Add item to WantedXLinks value
     * @throws \InvalidArgumentException
     * @param \Pixelboxx\StructType\XLinkObjectsRequestType $item
     * @return \Pixelboxx\StructType\XLinkListObjectsRequestType
     */
    public function addToWantedXLinks(\Pixelboxx\StructType\XLinkObjectsRequestType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \Pixelboxx\StructType\XLinkObjectsRequestType) {
            throw new \InvalidArgumentException(sprintf('The WantedXLinks property can only contain items of type \Pixelboxx\StructType\XLinkObjectsRequestType, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->WantedXLinks[] = $item;
        return $this;
    }
}
