<?php

namespace Pixelboxx\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for XLinkListRefsType StructType
 * @subpackage Structs
 */
class XLinkListRefsType extends AbstractStructBase
{
    /**
     * The XLink
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 1
     * @var \Pixelboxx\StructType\XLinkRefsType[]
     */
    public $XLink;
    /**
     * Constructor method for XLinkListRefsType
     * @uses XLinkListRefsType::setXLink()
     * @param \Pixelboxx\StructType\XLinkRefsType[] $xLink
     */
    public function __construct(array $xLink = array())
    {
        $this
            ->setXLink($xLink);
    }
    /**
     * Get XLink value
     * @return \Pixelboxx\StructType\XLinkRefsType[]
     */
    public function getXLink()
    {
        return $this->XLink;
    }
    /**
     * This method is responsible for validating the values passed to the setXLink method
     * This method is willingly generated in order to preserve the one-line inline validation within the setXLink method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateXLinkForArrayConstraintsFromSetXLink(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $xLinkListRefsTypeXLinkItem) {
            // validation for constraint: itemType
            if (!$xLinkListRefsTypeXLinkItem instanceof \Pixelboxx\StructType\XLinkRefsType) {
                $invalidValues[] = is_object($xLinkListRefsTypeXLinkItem) ? get_class($xLinkListRefsTypeXLinkItem) : sprintf('%s(%s)', gettype($xLinkListRefsTypeXLinkItem), var_export($xLinkListRefsTypeXLinkItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The XLink property can only contain items of type \Pixelboxx\StructType\XLinkRefsType, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set XLink value
     * @throws \InvalidArgumentException
     * @param \Pixelboxx\StructType\XLinkRefsType[] $xLink
     * @return \Pixelboxx\StructType\XLinkListRefsType
     */
    public function setXLink(array $xLink = array())
    {
        // validation for constraint: array
        if ('' !== ($xLinkArrayErrorMessage = self::validateXLinkForArrayConstraintsFromSetXLink($xLink))) {
            throw new \InvalidArgumentException($xLinkArrayErrorMessage, __LINE__);
        }
        $this->XLink = $xLink;
        return $this;
    }
    /**
     * Add item to XLink value
     * @throws \InvalidArgumentException
     * @param \Pixelboxx\StructType\XLinkRefsType $item
     * @return \Pixelboxx\StructType\XLinkListRefsType
     */
    public function addToXLink(\Pixelboxx\StructType\XLinkRefsType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \Pixelboxx\StructType\XLinkRefsType) {
            throw new \InvalidArgumentException(sprintf('The XLink property can only contain items of type \Pixelboxx\StructType\XLinkRefsType, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->XLink[] = $item;
        return $this;
    }
}
