<?php

namespace Pixelboxx\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for XLinkObjectsRequestType StructType
 * @subpackage Structs
 */
class XLinkObjectsRequestType extends AbstractStructBase
{
    /**
     * The type
     * Meta information extracted from the WSDL
     * - base: xs:token
     * - use: required
     * @var string
     */
    public $type;
    /**
     * The WithMetadata
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \Pixelboxx\StructType\MetadataRequestType
     */
    public $WithMetadata;
    /**
     * The WithRawData
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \Pixelboxx\StructType\RawDataListRequestType
     */
    public $WithRawData;
    /**
     * The rel
     * Meta information extracted from the WSDL
     * - default: child
     * - use: optional
     * @var string
     */
    public $rel;
    /**
     * Constructor method for XLinkObjectsRequestType
     * @uses XLinkObjectsRequestType::setType()
     * @uses XLinkObjectsRequestType::setWithMetadata()
     * @uses XLinkObjectsRequestType::setWithRawData()
     * @uses XLinkObjectsRequestType::setRel()
     * @param string $type
     * @param \Pixelboxx\StructType\MetadataRequestType $withMetadata
     * @param \Pixelboxx\StructType\RawDataListRequestType $withRawData
     * @param string $rel
     */
    public function __construct($type = null, \Pixelboxx\StructType\MetadataRequestType $withMetadata = null, \Pixelboxx\StructType\RawDataListRequestType $withRawData = null, $rel = 'child')
    {
        $this
            ->setType($type)
            ->setWithMetadata($withMetadata)
            ->setWithRawData($withRawData)
            ->setRel($rel);
    }
    /**
     * Get type value
     * @return string
     */
    public function getType()
    {
        return $this->type;
    }
    /**
     * Set type value
     * @param string $type
     * @return \Pixelboxx\StructType\XLinkObjectsRequestType
     */
    public function setType($type = null)
    {
        // validation for constraint: string
        if (!is_null($type) && !is_string($type)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($type, true), gettype($type)), __LINE__);
        }
        $this->type = $type;
        return $this;
    }
    /**
     * Get WithMetadata value
     * @return \Pixelboxx\StructType\MetadataRequestType|null
     */
    public function getWithMetadata()
    {
        return $this->WithMetadata;
    }
    /**
     * Set WithMetadata value
     * @param \Pixelboxx\StructType\MetadataRequestType $withMetadata
     * @return \Pixelboxx\StructType\XLinkObjectsRequestType
     */
    public function setWithMetadata(\Pixelboxx\StructType\MetadataRequestType $withMetadata = null)
    {
        $this->WithMetadata = $withMetadata;
        return $this;
    }
    /**
     * Get WithRawData value
     * @return \Pixelboxx\StructType\RawDataListRequestType|null
     */
    public function getWithRawData()
    {
        return $this->WithRawData;
    }
    /**
     * Set WithRawData value
     * @param \Pixelboxx\StructType\RawDataListRequestType $withRawData
     * @return \Pixelboxx\StructType\XLinkObjectsRequestType
     */
    public function setWithRawData(\Pixelboxx\StructType\RawDataListRequestType $withRawData = null)
    {
        $this->WithRawData = $withRawData;
        return $this;
    }
    /**
     * Get rel value
     * @return string|null
     */
    public function getRel()
    {
        return $this->rel;
    }
    /**
     * Set rel value
     * @uses \Pixelboxx\EnumType\XLinkRelationType::valueIsValid()
     * @uses \Pixelboxx\EnumType\XLinkRelationType::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $rel
     * @return \Pixelboxx\StructType\XLinkObjectsRequestType
     */
    public function setRel($rel = 'child')
    {
        // validation for constraint: enumeration
        if (!\Pixelboxx\EnumType\XLinkRelationType::valueIsValid($rel)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \Pixelboxx\EnumType\XLinkRelationType', is_array($rel) ? implode(', ', $rel) : var_export($rel, true), implode(', ', \Pixelboxx\EnumType\XLinkRelationType::getValidValues())), __LINE__);
        }
        $this->rel = $rel;
        return $this;
    }
}
